"use strict";

var _core = require("babel-runtime/core-js")["default"];

var _require = require("./util");

var request = _require.request;

var err = function (repo, message) {
  return _core.Object.assign(new Error(message), { repo: repo });
};

var migrate = "/api/v1/repos/migrate";

// Migrate repository to Gogs.

module.exports = function (opts) {
  return function (repo) {
    return request("" + opts.prefix + "" + migrate, {
      method: "post",
      json: true,
      headers: {
        authorization: "token " + opts.token
      },
      form: _core.Object.assign({
        uid: opts.uid,
        clone_addr: repo.url,
        repo_name: repo.name,
        desc: repo.desc
      }, repo["private"] && { "private": true }, opts.auth && {
        auth_username: opts.auth.user,
        auth_password: opts.auth.pass
      }, opts.mirror && { mirror: true }, opts["private"] && { "private": true }, {})
    }).doto(function (response) {
      if (response.statusCode === 500) return; // 500 errors have a JSON message.
      if (response.statusCode === 200 || response.statusCode === 201) return; // JSON response.
      throw err(repo, "Unexpected status " + response.statusCode + " from " + opts.prefix + "" + migrate);
    }).map(function (response) {
      return _core.Object.assign({ repo: repo }, response.body);
    }).doto(function (_ref) {
      var message = _ref.message;

      if (message) throw err(repo, message);
    });
  };
};